'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getIterator2;

function _load_getIterator() {
  return _getIterator2 = _interopRequireDefault(require('babel-runtime/core-js/get-iterator'));
}

exports.default = function (config) {
  if (!config) return;

  for (var _len = arguments.length, properties = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    properties[_key - 1] = arguments[_key];
  }

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, (_getIterator2 || _load_getIterator()).default)(properties), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var property = _step.value;

      var color = config[property];
      if (color && !(isHexColor(color) || isCssColor(color) || isRgbColor(color) || isRgbaColor(color))) {
        throw new (_PresetError || _load_PresetError()).default(property, color);
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
};

var _cssColorNames;

function _load_cssColorNames() {
  return _cssColorNames = _interopRequireDefault(require('css-color-names'));
}

var _PresetError;

function _load_PresetError() {
  return _PresetError = _interopRequireDefault(require('../errors/PresetError'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isHexColor(color) {
  return (/^#([0-9a-fA-F]{3,4}|[0-9a-fA-F]{6}|[0-9a-fA-F]{8})$/.test(color)
  );
}

function isCssColor(color) {
  return typeof color === 'string' && (_cssColorNames || _load_cssColorNames()).default[color];
}

function isRgbColor(color) {
  return (/rgb\([\d]{1,3}, [\d]{1,3}, [\d]{1,3}\)/.test(color)
  );
}

function isRgbaColor(color) {
  return (/rgba\([\d]{1,3}, [\d]{1,3}, [\d]{1,3}, \d\.\d+\)/.test(color)
  );
}

module.exports = exports['default'];
//# sourceMappingURL=../__sourcemaps__/validators/Colors.js.map
